

typedef BOOLEAN handerFunction(FILE *outFile, UINT16 instruction, UINT16 address, const struct picDef *procDev, UINT16 opNum);
 
typedef struct opcodeDef
{
	char *mnemonic;				// pointer to instruction mnemonic
	UINT16 opcode;				// portion of opcode which identifies the instruction
	UINT16 mask;				// mask to get just the identifying portion
	UINT16 f;					// register file address, if any
	UINT16 d;					// destination address, if any (0 = W, 1 = f)
	UINT16 b;					// bit number
	UINT16 bposn;				// number of bits b is shifted up
	UINT16 k;					// constant
	handerFunction *handler;	// handler to finish with this opcode
} OPCODE_DEF;

// object to substitute a label for a value
typedef struct
{
	char *name;
	UINT8 value;
	const char **bitNames;			// pointer to bit names list, if any
} SYMBOLNAME;


// object to define a processor
typedef struct picDef
{
	char *name;						// pointer to part name
	const OPCODE_DEF *opcodeList;	// pointer to opcode definitions
	const SYMBOLNAME *regFileList;	// pointer to register file symbol list
} PIC_DEF;


extern const PIC_DEF *procDef;

extern void DisassembleInstruction(FILE *outFile, UINT16 instruction, UINT16 address, const PIC_DEF *procDev);
extern const PIC_DEF *InitDisassemble(char *partName);
extern void ShowDevices();
